#ifndef __SHM_COMM_H
#define __SHM_COMM_H

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <unistd.h>


#define PATH "/home/zzk/2024-OSAPP/Linux_Lifecycle/include/shm_comm.h"
#define PROJID 0x3333


#define SHM_START_OFFSET (2*sizeof(unsigned))
#define SHM_TOTAL_SIZE 204800
#define SHM_SIZE (SHM_TOTAL_SIZE - SHM_START_OFFSET)



#define SHM_REAR_OFFSET 0
#define SHM_FRONT_OFFSET (sizeof(unsigned))

#define SHM_GET_REAR(shm_begin) (*(unsigned*)(shm_begin+SHM_REAR_OFFSET))
#define SHM_GET_FRONT(shm_begin) (*(unsigned*)(shm_begin+SHM_FRONT_OFFSET))
// #define SHM_SIZE (SHM_DATA_SIZE + sizeof(ssize_t))
// enum event_type {
//     EVENT_TIMESTAMP = 0,
//     EVENT_OFFCPU,
//     EVENT_WAKEUP,
//     EVENT_SYSCALL,
//     EVENT_SOFTIRQ,
//     EVENT_HARDIRQ,
//     EVENT_SIGNAL,
// };


// 要牺牲一个位置
#define GET_REMAINING_SPACE(shm_begin) ((SHM_GET_FRONT(shm_begin) - SHM_GET_REAR(shm_begin) + SHM_SIZE - 1) % SHM_SIZE) 
const mode_t shm_mode = 0666;

key_t getKey()
{
    key_t k = ftok(PATH, PROJID);
    if(k == -1) {
        fprintf(stderr, "shm ftok error\n");
    }
    return k;
}

int createShm(key_t shm_key)
{
    int sid = shmget(shm_key, SHM_TOTAL_SIZE, IPC_CREAT|IPC_EXCL|shm_mode);
    if(sid == -1) {
        fprintf(stderr, "shm shmget error\n");
    }
    return sid;
}

int getShm(key_t shm_key)
{
    int sid = shmget(shm_key, SHM_SIZE, IPC_CREAT);

    return sid;
}

char* processAssociation(int shm_id)
{
    char* start = (char*)shmat(shm_id, NULL, 0);
    return start;
}

int deAssociation(void* start)
{
    return shmdt(start);
}

int shmRelease(int shm_id)
{
    return shmctl(shm_id, IPC_RMID, NULL);

}
#endif /* __SHM_COMM_H */